#ifndef __DRIVER_H__
#define __DRIVER_H__

#ifndef __cplusplus
	#define EXTERN_	extern
#else
	#define EXTERN_	extern "C"
#endif


#include "interface.h"
#include "memory_extern.h"

typedef	struct
{
	int				*pInterruptMask;
	unsigned char	*pRDRAM;
	unsigned char	*pDMEM;
	unsigned char	*pIMEM;	
	unsigned char	*pVIREG;
}tCoreConnection;


//** Video functions
typedef int  (*fnVid_InitDLL_T)(void);
typedef void (*fnVid_UnInitDLL_T)(void);
typedef int  (*fnVid_InitVideo_T)(HWND, HINSTANCE);
typedef	void (*fnVid_ReleaseVideo_T)();
typedef void (*fnVid_ExecuteDList_T)(__int32 addr);
typedef	void (*fnVid_SetUcode_T)(int);
typedef	void (*fnVid_CreateConnectionWithCore_T)(tCoreConnection *);
typedef	void (*fnVid_RefreshVisual2D_T)(void);

//** Audio functions;

typedef int  (*fnAud_InitDLL_T)();
typedef int  (*fnAud_InitAudio_T)(HWND, HINSTANCE);
typedef void (*fnAud_ReleaseAudio_T)();
typedef void (*fnAud_ExecuteSList_T)();
typedef void (*fnAud_CreateConnectionWithCore_T)(tCoreConnection *);

#ifdef CORE
//** Video
	EXTERN_	int  LoadVideoDriver();    // this calls InitDLL itself
	EXTERN_	void ReleaseVideoDriver(); // this calls UnInitDLL itself

	//** wrapped video dll functions 
	EXTERN_ int  Vid_InitVideo(HWND, HINSTANCE);
	EXTERN_	void Vid_ReleaseVideo();
	EXTERN_	void Vid_CreateConnectionWithCore(tCoreConnection *);
	EXTERN_	void Vid_SetUCode(int);
	EXTERN_ void Vid_ExecuteDList(__int32 addr);

//** Audio
	EXTERN_	int  LoadAudioDriver();    // this calls InitDLL itself
	EXTERN_	int  LoadAudioDriver2();    // this calls InitDLL itself
	EXTERN_	void ReleaseAudioDriver(); // this calls UnInitDLL itself

	//** wrapped audio dll functions 
	EXTERN_ void Aud_CreateConnectionWithCore(tCoreConnection *);
	EXTERN_ void Aud_InitAudio(HWND, HINSTANCE);
	EXTERN_ void Aud_ReleaseAudio();
	EXTERN_ void Aud_ExecuteSList();

#endif
#endif
