/**
 * TrueReality - file_loader.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/

/* This is the port to the windows handling ...
   The complete init and the shutdown is done by this file
   In the future this file will handle things like "save cpu-state" too.
*/


#include <windows.h>

#include "global/type_sizes.h"
#include "global/config.h"

#include "_dispatch.h"

#include "file_loader.h"
#include "file_loader_extern.h"


struct tr_prefs prefs;

char RealName[1024];
int Init_Emulator(char *RomName)
{
	prefs.load_what = N64_NOTHING;
    prefs.plugged_controller        = CONTR_1;
    prefs.symbols                   = NO_SYMBOLS;
	prefs.eeprom = 0;			//WaveRacer = 0;

	strcpy(RealName, RomName);
	rominfo.real_name = RealName;

    if(dispatch(MEMORY_ALLOC, NULL) < 0) return(-1);

// ** Load the RomFile
    if(load_files() < 0)                         /* from 'file_loader.c' */
    {
		dispatch(MEMORY_FREE, NULL);
        return(-1);
    }

// ** 
    if(copy_code() < 0)                          /* from 'file_loader.c' */
    {
	   dispatch(MEMORY_FREE, NULL);
       return(-1);
    }

// **
	dispatch(CONTROLLER_INIT, NULL);

    dispatch(AUDIO_OPEN, NULL);
    dispatch(CPU_RESET, NULL);

	return 1;
}

int Shut_Emulator(void)
{
	dispatch(SHUTDOWN, NULL);
	return(1);
}
