#ifndef __CONFIG_H
#define __CONFIG_H


#include "type_sizes.h"

typedef struct
{
        uWORD   addr;
        char    *name;

}
tr_stab; /* typedef struct */



struct tr_prefs
{
        /* :) ... a developer need this */
        
        uDWORD  debug;
                
        /* N64 image or DMEM/IMEM binaries */

        int     load_what;

        /* Symbols */
        
        int     symbols;
        char    *symbol_file;
        int     n_symbols;      /* there are n_symbols symbols in table */
        tr_stab *symtab;
           
        /* Display */
        
        int     display;
        
        /* Controller/Cartridge */
        
        int     plugged_controller;
        int     eeprom;
            
        /* Joystick */
        
        int     joystick;
        

        
        /* Sound */
        
        int     sound;
        char    *sound_file;
        int     sound_bits;
        int     sound_freq;
        int     sound_stereo;

       
}; /* struct tr_prefs */


/*** extern section ***/

extern struct tr_prefs prefs;



/*** define section ***/

/* tr_prefs.load_what */

#define N64_NOTHING     0       /* These 4 defines are used to    */
#define N64_IMAGE       1       /* determinate                    */
#define N64_IMEM        2       /* if an image or dmem/imem       */
#define N64_DMEM        4       /* is/are to load.                */



/* tr_prefs.symbols */

#define NO_SYMBOLS              0
#define USE_SYMBOLS             1



/* tr_prefs.sound */

#define NO_SOUND                0
#define NORMAL_SOUND            1
#define FILE_SOUND              2



/* tr_prefs.joystick */

#define NO_JOYSTICK             0
#define USE_JOYSTICK            1


/* tr_prefs.debug */

#define DBG_CPU_INSTR           0x0000000000000001L
#define DBG_CPU_COUNT           0x0000000000000002L
#define DBG_CPU_REG             0x0000000000000004L
#define DBG_NATIVE              0x0000000000000008L
#define DBG_RSP_INSTR           0x0000000000000010L
#define DBG_RSP_COUNT           0x0000000000000020L
#define DBG_RSP_REG             0x0000000000000040L
#define DBG_RDP                 0x0000000000000080L

#define DBG_INTR_ALL            0x000000000000ff00L
#define DBG_INTR_COMP           0x0000000000000100L
#define DBG_INTR_VI             0x0000000000000200L
#define DBG_INTR_SI             0x0000000000000400L
#define DBG_INTR_SP             0x0000000000000800L
#define DBG_INTR_PI             0x0000000000001000L
#define DBG_INTR_AI             0x0000000000002000L
#define DBG_INTR_DP             0x0000000000004000L

#define DBG_MEMORY_ALL          0x00000fffffff0000L
#define DBG_MEMORY              0x0000000000010000L
#define DBG_RD_RAM              0x0000000000020000L
#define DBG_RD_REG              0x0000000000040000L
#define DBG_SP_DMEM             0x0000000000080000L
#define DBG_SP_IMEM             0x0000000000100000L
#define DBG_SP_REG              0x0000000000200000L
#define DBG_SP_PC_REG           0x0000000000400000L
#define DBG_SP_IBIST_REG        0x0000000000800000L
#define DBG_DPC_REG             0x0000000001000000L
#define DBG_DPS_REG             0x0000000002000000L
#define DBG_MI_REG              0x0000000004000000L
#define DBG_VI_REG              0x0000000008000000L
#define DBG_AI_REG              0x0000000010000000L
#define DBG_PI_REG              0x0000000020000000L
#define DBG_RI_REG              0x0000000040000000L
#define DBG_SI_REG              0x0000000080000000L
#define DBG_PI_DOM2_ADDR1       0x0000000100000000L
#define DBG_PI_DOM1_ADDR1       0x0000000200000000L
#define DBG_PI_DOM2_ADDR2       0x0000000400000000L
#define DBG_PI_DOM1_ADDR2       0x0000000800000000L
#define DBG_PI_ROM              0x0000001000000000L
#define DBG_PI_RAM              0x0000002000000000L
#define DBG_PI_DOM1_ADDR3       0x0000004000000000L

#define DBG_DISP                0x0000f00000000000L
#define DBG_DISP_REFRESH        0x0000100000000000L
#define DBG_DISP_MODE           0x0000200000000000L

#define DBG_CONTR_ALL           0x000f000000000000L
#define DBG_CONTR_PIF           0x0001000000000000L
#define DBG_CONTR_BUTTONS       0x0002000000000000L

#define DBG_AUDIO               0x0008000000000000L

#define DBG_EXC                 0xfff0000000000000L
#define DBG_EXC_OV              0x0010000000000000L
#define DBG_EXC_FPE             0x0020000000000000L
#define DBG_EXC_TR              0x0040000000000000L
#define DBG_EXC_BP              0x0080000000000000L
#define DBG_EXC_SYS             0x0100000000000000L
#define DBG_EXC_RI              0x0200000000000000L



/* tr_prefs.plugged_controller */

#define MAX_CONTR       4      /* BUG: maybe 6 ???*/

#define NOCONTR         0x00
#define CONTR_1         0x01
#define CONTR_2         0x02
#define CONTR_3         0x04
#define CONTR_4         0x08
#define CONTR_5         0x10    /* BUG: ??? */
#define CONTR_6         0x20    /* BUG: ??? */



#endif 

