#ifdef TRWIN

	#include "stdafx.h"
	#include "math.h"
	#include "N64Em.h"

#else


#endif

#define PAGE_SIZE	4096
#define NUM_PAGES	256			// i don't suggest that you change these, as other parts of the code, however limited, take
								// advantage of the bit patterns to calculate page/offsets

extern unsigned __int32 dynaOpCode;
extern unsigned __int32 dynaNextOpCode;
extern unsigned __int32 dynaPreCompileLength;
extern unsigned char *dynaCompileTargetPtr;
extern unsigned __int32 *dynaRam;					//source for what we are compiling, must be global so that branch ops can get next instruction
extern unsigned __int16 dynaSrc;
extern unsigned __int32 dynaRegPtr;				// this points to a data structure that contains the GPR,CPR,CCR,PC etc. for the 4300
extern unsigned char dynaForceFallOut;
extern unsigned __int32 dynaLengthTable[PAGE_SIZE];
extern unsigned char *dynaCPUInfo;				// this points to a data structure that contains the GPR,CPR,CCR,PC etc. for the 4300
extern unsigned __int32 InterpHelperAddress;
extern unsigned __int32 helperLoadDWordAddress;
extern unsigned __int32 helperLoadWordAddress;
extern unsigned __int32 helperLoadHalfAddress;
extern unsigned __int32 helperLoadByteAddress;
extern unsigned __int32 helperStoreDWordAddress;
extern unsigned __int32 helperStoreWordAddress;
extern unsigned __int32 helperStoreHalfAddress;
extern unsigned __int32 helperStoreByteAddress;


extern unsigned char *dynaRamPtr;
extern unsigned __int32 dynaPCPtr;
extern unsigned __int32 dynaICount;
extern unsigned __int32 dynaVCount;
extern unsigned __int32 helperCheckIntsAddress;
//extern unsigned __int32 ICountPtr;
//extern unsigned __int32 CompareCountPtr;

extern void dynaInit();
extern void dynaDestroy();
extern unsigned char dynaExecute(unsigned __int32 Address);
extern void dynaInvalidate(unsigned __int32 Start,unsigned __int32 Length);
extern unsigned char dynaPreCompilePage(unsigned __int32 Address);
extern unsigned char dynaCompilePage(unsigned __int32 Address);
extern unsigned __int16 dynaCompile_sll(unsigned char *dst);
extern unsigned __int16 dynaCompile_srl(unsigned char *dst);
extern unsigned __int16 dynaCompile_sra(unsigned char *dst);
extern unsigned __int16 dynaCompile_sllv(unsigned char *dst);
extern unsigned __int16 dynaCompile_srlv(unsigned char *dst);
extern unsigned __int16 dynaCompile_srav(unsigned char *dst);
extern unsigned __int16 dynaCompile_jr(unsigned char *dst);
extern unsigned __int16 dynaCompile_jalr(unsigned char *dst);
extern unsigned __int16 dynaCompile_syscall(unsigned char *dst);
extern unsigned __int16 dynaCompile_Break(unsigned char *dst);
extern unsigned __int16 dynaCompile_reserved(unsigned char *dst);
extern unsigned __int16 dynaCompile_sync(unsigned char *dst);
extern unsigned __int16 dynaCompile_mfhi(unsigned char *dst);
extern unsigned __int16 dynaCompile_mthi(unsigned char *dst);
extern unsigned __int16 dynaCompile_mflo(unsigned char *dst);
extern unsigned __int16 dynaCompile_mtlo(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsllv(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsrlv(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsrav(unsigned char *dst);
extern unsigned __int16 dynaCompile_mult(unsigned char *dst);
extern unsigned __int16 dynaCompile_multu(unsigned char *dst);
extern unsigned __int16 dynaCompile_div(unsigned char *dst);
extern unsigned __int16 dynaCompile_divu(unsigned char *dst);
extern unsigned __int16 dynaCompile_dmult(unsigned char *dst);
extern unsigned __int16 dynaCompile_dmultu(unsigned char *dst);
extern unsigned __int16 dynaCompile_ddiv(unsigned char *dst);
extern unsigned __int16 dynaCompile_ddivu(unsigned char *dst);
extern unsigned __int16 dynaCompile_add(unsigned char *dst);
extern unsigned __int16 dynaCompile_addu(unsigned char *dst);
extern unsigned __int16 dynaCompile_sub(unsigned char *dst);
extern unsigned __int16 dynaCompile_subu(unsigned char *dst);
extern unsigned __int16 dynaCompile_and(unsigned char *dst);
extern unsigned __int16 dynaCompile_or(unsigned char *dst);
extern unsigned __int16 dynaCompile_xor(unsigned char *dst);
extern unsigned __int16 dynaCompile_nor(unsigned char *dst);
extern unsigned __int16 dynaCompile_slt(unsigned char *dst);
extern unsigned __int16 dynaCompile_sltu(unsigned char *dst);
extern unsigned __int16 dynaCompile_dadd(unsigned char *dst);
extern unsigned __int16 dynaCompile_daddu(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsub(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsubu(unsigned char *dst);
extern unsigned __int16 dynaCompile_tge(unsigned char *dst);
extern unsigned __int16 dynaCompile_tgeu(unsigned char *dst);
extern unsigned __int16 dynaCompile_tlt(unsigned char *dst);
extern unsigned __int16 dynaCompile_tltu(unsigned char *dst);
extern unsigned __int16 dynaCompile_teq(unsigned char *dst);
extern unsigned __int16 dynaCompile_tne(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsll(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsrl(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsra(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsll32(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsrl32(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsra3(unsigned char *dst);
extern unsigned __int16 dynaCompile_special(unsigned char *dst);
extern unsigned __int16 dynaCompile_regimm(unsigned char *dst);
extern unsigned __int16 dynaCompile_j(unsigned char *dst);
extern unsigned __int16 dynaCompile_jal(unsigned char *dst);
extern unsigned __int16 dynaCompile_beq(unsigned char *dst);
extern unsigned __int16 dynaCompile_bne(unsigned char *dst);
extern unsigned __int16 dynaCompile_blez(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgtz(unsigned char *dst);
extern unsigned __int16 dynaCompile_addi(unsigned char *dst);
extern unsigned __int16 dynaCompile_addiu(unsigned char *dst);
extern unsigned __int16 dynaCompile_slti(unsigned char *dst);
extern unsigned __int16 dynaCompile_sltiu(unsigned char *dst);
extern unsigned __int16 dynaCompile_andi(unsigned char *dst);
extern unsigned __int16 dynaCompile_ori(unsigned char *dst);
extern unsigned __int16 dynaCompile_xori(unsigned char *dst);
extern unsigned __int16 dynaCompile_lui(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop2(unsigned char *dst);
extern unsigned __int16 dynaCompile_beql(unsigned char *dst);
extern unsigned __int16 dynaCompile_bnel(unsigned char *dst);
extern unsigned __int16 dynaCompile_blezl(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgtzl(unsigned char *dst);
extern unsigned __int16 dynaCompile_daddi(unsigned char *dst);
extern unsigned __int16 dynaCompile_daddiu(unsigned char *dst);
extern unsigned __int16 dynaCompile_ldl(unsigned char *dst);
extern unsigned __int16 dynaCompile_ldr(unsigned char *dst);
extern unsigned __int16 dynaCompile_lb(unsigned char *dst);
extern unsigned __int16 dynaCompile_lh(unsigned char *dst);
extern unsigned __int16 dynaCompile_lwl(unsigned char *dst);
extern unsigned __int16 dynaCompile_lw(unsigned char *dst);
extern unsigned __int16 dynaCompile_lbu(unsigned char *dst);
extern unsigned __int16 dynaCompile_lhu(unsigned char *dst);
extern unsigned __int16 dynaCompile_lwr(unsigned char *dst);
extern unsigned __int16 dynaCompile_lwu(unsigned char *dst);
extern unsigned __int16 dynaCompile_sb(unsigned char *dst);
extern unsigned __int16 dynaCompile_sh(unsigned char *dst);
extern unsigned __int16 dynaCompile_swl(unsigned char *dst);
extern unsigned __int16 dynaCompile_sw(unsigned char *dst);
extern unsigned __int16 dynaCompile_sdl(unsigned char *dst);
extern unsigned __int16 dynaCompile_sdr(unsigned char *dst);
extern unsigned __int16 dynaCompile_swr(unsigned char *dst);
extern unsigned __int16 dynaCompile_cache(unsigned char *dst);
extern unsigned __int16 dynaCompile_ll(unsigned char *dst);
extern unsigned __int16 dynaCompile_lwc1(unsigned char *dst);
extern unsigned __int16 dynaCompile_lwc2(unsigned char *dst);
extern unsigned __int16 dynaCompile_lld(unsigned char *dst);
extern unsigned __int16 dynaCompile_ldc1(unsigned char *dst);
extern unsigned __int16 dynaCompile_ldc2(unsigned char *dst);
extern unsigned __int16 dynaCompile_ld(unsigned char *dst);
extern unsigned __int16 dynaCompile_sc(unsigned char *dst);
extern unsigned __int16 dynaCompile_swc1(unsigned char *dst);
extern unsigned __int16 dynaCompile_swc2(unsigned char *dst);
extern unsigned __int16 dynaCompile_scd(unsigned char *dst);
extern unsigned __int16 dynaCompile_sdc1(unsigned char *dst);
extern unsigned __int16 dynaCompile_sdc2(unsigned char *dst);
extern unsigned __int16 dynaCompile_s(unsigned char *dst);
extern unsigned __int16 dynaCompile_bltz(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgez(unsigned char *dst);
extern unsigned __int16 dynaCompile_bltzl(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgezl(unsigned char *dst);
extern unsigned __int16 dynaCompile_tgei(unsigned char *dst);
extern unsigned __int16 dynaCompile_tgeiu(unsigned char *dst);
extern unsigned __int16 dynaCompile_tlti(unsigned char *dst);
extern unsigned __int16 dynaCompile_tltiu(unsigned char *dst);
extern unsigned __int16 dynaCompile_teqi(unsigned char *dst);
extern unsigned __int16 dynaCompile_tnei(unsigned char *dst);
extern unsigned __int16 dynaCompile_bltzal(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgezal(unsigned char *dst);
extern unsigned __int16 dynaCompile_bltzall(unsigned char *dst);
extern unsigned __int16 dynaCompile_bgezall(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_mf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_dmf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_cf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_mt(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_dmt(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_ct(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_bc(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rs_co(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rt_bcf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rt_bct(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rt_bcfl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_rt_bctl(unsigned char *dst);
extern unsigned __int16 dynaCompile_invalid(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_tlbr(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_tlbwi(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_tlbwr(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_tlbp(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop0_eret(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_mf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_dmf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_cf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_mt(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_dmt(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_ct(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_bc(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rs_co(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rt_bcf(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rt_bct(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rt_bcfl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_rt_bctl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_add(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_sub(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_mul(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_div(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_sqrt(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_abs(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_mov(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_neg(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_roundl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_truncl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_ceill(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_floorl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_roundw(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_truncw(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_ceilw(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_floorw(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_cvts(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_cvtd(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_cvtw(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_cvtl(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop1_c(unsigned char *dst);
extern unsigned __int16 dynaCompile_cop2_rs_not_implemented(unsigned char *dst);
extern unsigned __int16 dynaCompile_dsra32(unsigned char *dst);
extern unsigned __int16 dynaCompile_sd(unsigned char *dst);
extern unsigned __int16 dynaFallOut(unsigned char *dst);
