/**
 * TrueReality - file_loader.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>

#include <GL/gl.h>
#include <GL/glu.h>

#include "display.h"
#include "rdp_registers.h"

uWORD flags;	
HWND HWNDMss;
void msg_box(char *textl)
{
	MessageBox(HWNDMss, textl, "Display", MB_OK);
}

int RePaint;				// are used by DEBUG.cpp and MAIN.cpp
extern int iRenderWindowX;
extern int iRenderWindowY;
extern BOOL Draw2d;
extern	char	*pVIREG;
extern	char	*pRDRAM;
extern	char	*pIDMEM;


void DrawScreenGL(unsigned int width, unsigned int height,unsigned int Scrwidth, unsigned int Scrheight, unsigned int mode);
//********************************************************************************
//** Init Stuff																	**
//********************************************************************************

int OpenVisual()
{
	return 0;
}
int CloseVisual()
{
	return 0;
}
void GetVisualName(char *name, int *n)
{
}
void SetVisualTitle(char *name)
{
}

//********************************************************************************
//** For 2d-demos only, very, very, 'uncool' hack							    **
//********************************************************************************

void RefreshVisual()
{
	uWORD    width, height, mode;
	if (Draw2d)
	{
		width = ((uWORD *)pVIREG)[2];
		mode = ((uWORD *)pVIREG)[0] & 0x03;
		height = (width * 3) >> 2;
		if ((width == 0) || (height == 0)) return;
		DrawScreenGL(256, 256,width,height,mode);
		RePaint = 1;
		Render_FlushVisualRenderBuffer();
	}
} 

/* This will draw the current n64 frame buffer to the screen */
/* At the moment only 15 bit graphics at a resolution of 320*240 is supported. */
/* It probably only works right with big endian at the momment. */
/* This routine was coded by Gil Pedersen */

static unsigned char tbuffer[256*256*4];
void DrawScreenGL(unsigned int width, unsigned int height,unsigned int Scrwidth, unsigned int Scrheight, unsigned int mode)
{
	unsigned long i, j, ulx, uly;

	uHWORD *src, *base_src_ptr;
	uWORD *lsrc, *lbase_src_ptr;
	unsigned char *dest;
	GLint hadDepthTest, hadBlending;

	glGetIntegerv(GL_DEPTH_TEST, &hadDepthTest); //** Should be glGetBooleanv, but 
	glDisable(GL_DEPTH_TEST);
	glGetIntegerv(GL_BLEND, &hadBlending); //** Should be glGetBooleanv, but 
	glDisable(GL_BLEND);

    glMatrixMode(GL_PROJECTION);
	glPushMatrix();
    glLoadIdentity();
	glOrtho(0, Scrwidth, Scrheight, 0, -1, 1);
    glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
    glLoadIdentity();

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	glEnable(GL_TEXTURE_2D);

    base_src_ptr = (uHWORD*)(uWORD*)(pRDRAM + ((uWORD*)pVIREG)[1]);
    lbase_src_ptr = (uWORD*)(pRDRAM + ((uWORD*)pVIREG)[1]);
//	DecompressTexture(((uWORD*)pVIREG)[1], 0, 0, 256, 256, 2);

	for (ulx = 0; (ulx * 256)<Scrwidth; ulx++)
		for (uly = 0; (uly * 256)<Scrheight; uly++)
		{
		dest = (unsigned char*)tbuffer;
		if (mode = 2)
		for(i=0; i<height; i++)
		{			
			for(j=0; j<width; j++)
			{				
				src = (base_src_ptr + (i + (uly * 256))*Scrwidth) + (ulx * 256)+(j ^ 0x01);
				*(dest) = (((*src >> 11 ) & 0x001f)<<3); dest++;
				*(dest) = (((*src >>  6 ) & 0x001f)<<3); dest++;
				*(dest) = (((*src >>  1 ) & 0x001f)<<3); dest++;
				*(dest) = 0xff; dest++;  //** Alpha

			}
		}
		else
		for(i=0; i<height; i++)
		{			
			for(j=0; j<width; j++)
			{				
				lsrc = (lbase_src_ptr + (i + (uly * 256))*Scrwidth) + (ulx * 256)+(j ^ 0x01);
				*(dest) = (uBYTE)(((*lsrc >> 24 ) & 0x001f)<<3); dest++;
				*(dest) = (uBYTE)(((*lsrc >> 16 ) & 0x001f)<<3); dest++;
				*(dest) = (uBYTE)(((*lsrc >> 8 ) & 0x001f)<<3); dest++;
				*(dest) = 0xff; dest++;  //** Alpha

			}
		};
		glBindTexture(GL_TEXTURE_2D, 0);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGBA, 
		GL_UNSIGNED_BYTE, tbuffer);

		glBegin(GL_QUADS);
			glTexCoord2f(0.0f, 0.0f); glVertex2f((float)(ulx * 256) +  0.0f  ,(float)(uly * 256.0f) + 0.0f);
			glTexCoord2f(0.0f, 1.0f); glVertex2f((float)(ulx * 256) +  0.0f  ,(float)(uly * 256.0f) + 256.0f);			
			glTexCoord2f(1.0f, 1.0f); glVertex2f((float)(ulx * 256) +  256.0f,(float)(uly * 256.0f) + 256.0f);
			glTexCoord2f(1.0f, 0.0f); glVertex2f((float)(ulx * 256) +  256.0f,(float)(uly * 256.0f) + 0.0f);
		glEnd();
		} // end for ulx uly

	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
    glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	if (hadBlending) glEnable(GL_BLEND);
	if (hadDepthTest) glEnable(GL_DEPTH_TEST);
}


