

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "driver.h"
#include "wingl.h"

//** externals
void RealExecuteDList(unsigned __int32 dwAddr);
void RefreshVisual(void);

//** globals
BOOLEAN	 bFullScreen; // FullScreen Mode

int				*pInterruptMask;
unsigned char	*pRDRAM;
unsigned char	*pIDMEM;
unsigned char	*pVIREG;
//BOOL			Draw2d = FALSE;
BOOL			Draw2d = TRUE;
BOOL			NoBlending = FALSE;			
int				ucode_version = 0;



/*
===============================================================================

  All our exported functions...

===============================================================================
*/
__declspec(dllexport) int InitDLL(void)
{
	// any one time dll load init stuff
	return 0;
}

__declspec(dllexport) void UnInitDLL(void)
{
	// called just before the dll is released
}

__declspec(dllexport) int InitVideo(HWND hWnd, HINSTANCE hInstance)
{
	WinData.Width = 640;
	WinData.Height = 480;
	WinData.hInstance = hInstance;

	WinData.hWnd = hWnd;
	if(WinData.hWnd == NULL)
	{
		MessageBox(NULL, "Video DLL: hWnd sent is NULL!", szAppName, MB_OK|MB_ICONSTOP);
		return -1;
	}
	
	if(WGL_Init())
		return 0;
	else
		return -1;
}

__declspec(dllexport) void ReleaseVideo(void)
{
	WGL_UnInit();
}

__declspec(dllexport) void CreateConnectionWithCore(tCoreConnection *pCore)
{
	pInterruptMask = pCore->pInterruptMask;
	pRDRAM = pCore->pRDRAM;
	pIDMEM = pCore->pIMEM;
	pVIREG = pCore->pVIREG;
}

__declspec(dllexport) void SetUcode(int uCode)
{
	ucode_version = uCode;
}

__declspec(dllexport) void ExecuteDList(__int32 addr)
{
	RealExecuteDList(addr);
}

__declspec(dllexport) void RefreshVisual2D(void)
{
	RefreshVisual();
}

/* No longer used!
int	GetDriverCaps()
{
	return DRIVER_DO_RDP;
}*/
