#ifndef __VIDEO_DRIVER_H__
#define __VIDEO_DRIVER_H__
#ifndef __cplusplus
	#define EXTERN_	extern
#else
	#define EXTERN_	extern "C"
#endif
#include "wingl.h"
typedef	struct sDriverVertex
{
	float				x,y,z;
	unsigned char		r,g,b,a;
	float				s,t;
}tDriverVertex;
typedef struct sTextureDescriptor
{
	unsigned char		*pDatas;
	unsigned int		xSize;
	unsigned int		ySize;
	unsigned char		bFormat;
}
tTextureDescriptor;

typedef	struct
{
	int				*pInterruptMask;
	unsigned char	*pRDRAM;
	unsigned char	*pDMEM;
	unsigned char	*pIMEM;	
	unsigned char	*pVIREG;
}tCoreConnection;

#define	N64_CULL_NONE	0
#define	N64_CULL_BACK	1
#define	N64_CULL_FRONT	2

#define					DRIVER_DO_2D	1
#define					DRIVER_DO_3D	2
#define					DRIVER_DO_RDP	4

typedef	void			(*tCreateConnectionWithCore)(tCoreConnection *);
typedef void			(*tVideoDriverInitFunction)(void *);
typedef char			(*tVideoInitFunction)(HWND, HINSTANCE);
typedef	char			(*tVideoReleaseFunction)();
/*typedef char			(*tVideoCopyBufferFunction)(unsigned int *pBuffer,int xSize,int ySize);
typedef	char			(*tVideoDrawText)(const char *strBuffer,int x,int y);
typedef	char			(*tVideoDrawLine)(tDriverVertex v[2]);
typedef	char			(*tVideoFillRect)(int x1,int y1,int x2,int y2,unsigned long Color);
typedef	char			(*tVideoTextRect)(int x1,int y1,int x2,int y2,tTextureDescriptor *);

typedef	char			(*tVideoTriangle)(tDriverVertex	v[3]);
typedef	char			(*tVideoTexturedTriangle)(tDriverVertex	v[3],tTextureDescriptor *pTexture);
typedef unsigned short	*(*tDecompressBitmap)(unsigned char *,int ,int ,int );
typedef	char			(*tVideoFlipPages)();
typedef	void			(*tBeginScene)();
typedef	void			(*tEndScene)();
typedef	int				(*tGetDriverCaps)();*/
typedef void			(*tExecuteDList)(__int32 addr);
/*typedef	void			(*tSetCullMode)(unsigned long);
//typedef	void			*(*tGetInfo)(void);*/
typedef	void			(*tSetUcode)(int);
typedef	void			(*tRefreshVisual2D)(void);

typedef	void			(*tFlushScreen)();
typedef	struct	sVideoDriver
{
	tVideoInitFunction			InitVideo;
	tVideoReleaseFunction		ReleaseVideo;
	tExecuteDList				ExecuteDList;
	tCreateConnectionWithCore	CreateConnectionWithCore;
	tSetUcode					SetUCode;
	tRefreshVisual2D			RefreshVisual2D;
}tVideoDriver;

#ifdef CORE
	EXTERN_	char			bWindowed;
	EXTERN_	tVideoDriver	sVideoDriver;
	EXTERN_	void			InitVideoDriver(tVideoDriverInitFunction tInitFn);
	EXTERN_	void			ReleaseVideoDriver();
	EXTERN_	void			LoadVideoDriver(const char *strVideoDriver);
	EXTERN_ void			FlushScreen();

#endif
#endif